/*
  MethOS process structure and definitions
*/

#ifndef _METHOS_PROCESS_DEFS_H_
#define _METHOS_PROCESS_DEFS_H_

#include <oskit/uvm.h>
#include <oskit/sproc.h>
#include <oskit/threads/pthread.h>

/* The start address of heap in a user process */
/* 0x50000000 */
#define HEAP_START_ADDR	(OSKIT_UVM_MINUSER_ADDRESS + 0x10000000)

/* just 64kb */
#define HEAP_SIZE	0x10000

/* 0x40000000 - 0x60000000 */
#define PROCESS_SIZE	0x20000000

#define MAX_PROCESS_NAME 50

typedef struct {
  int procnum;
  int running;
  int type;
  char name[MAX_PROCESS_NAME];
  pthread_t control_thread;
  pthread_t process_thread;
  struct oskit_sproc sproc;
} mth_process;

#endif /*_METHOS_PROCESS_DEFS_H_*/
