/*
  MethOS I/O syscalls
 */

#ifndef _USER_SYSCALL_H_
#define _USER_SYSCALL_H_

#include <oskit/c/stdio.h>
#include <oskit/c/time.h>

void 	mth_exit (int);
void	mth_return (int);
int	mth_getchar ();
int 	mth_putchar (int c);
int	mth_printf (const char* format, ...);
int 	mth_sleep (int);
char*	mth_gets (char*);
int 	mth_puts (const char*);
int 	mth_lock (void);
int 	mth_unlock (void);
FILE*	mth_fopen (const char *path, const char *mode);
int 	mth_fclose (FILE* stream);
int	mth_fileexists (const char* path);
int 	mth_fprintf (FILE* file, const char* format, ...);
char*	mth_fgets (char* buffer, int size, FILE* stream);
int	mth_fputs (const char*, FILE* stream);
int 	mth_feof (FILE* stream);
void	srand (unsigned seed);
int	rand ();
int	atoi (const char* npr);
time_t	mth_time (time_t t);
void 	mth_process_yield ();

/*
  We don't want the minimal libc
*/

#define getchar mth_getchar
#define putchar mth_putchar
#define printf mth_printf
#define sleep mth_sleep
#define gets mth_gets
#define puts mth_puts
#define lock mth_lock
#define unlock mth_unlock
#define fopen mth_fopen
#define fclose mth_fclose
#define fprintf mth_fprintf
#define fgets mth_fgets
#define fputs mth_fputs
#undef 	feof
#define feof mth_feof
#define time mth_time

#endif /*_USER_SYSCALL_H_*/
