/*
  MethOS system call
 */

#include <oskit/machine/asm.h>
#include <oskit/machine/sproc.h>
#include <kernel/syscall_defs.h>

#define SYSCALL(name, no)			\
GEN_ENTRY(name)					\
	movl $no,%eax		; 		\
	int $0x60		; 		\
	jc cerror		; 		\
	ret

	.globl	EXT(errno)

GEN_ENTRY(cerror)
	movl	%eax,EXT(errno)
	movl	$-1,%eax
	movl	$-1,%edx
	ret	

SYSCALL(mth_exit, METHOS_SYSCALL_EXIT)
SYSCALL(mth_putchar, METHOS_SYSCALL_PUTCHAR)
SYSCALL(mth_getchar, METHOS_SYSCALL_GETCHAR)
SYSCALL(mth_printf, METHOS_SYSCALL_PRINTF)
SYSCALL(mth_sleep, METHOS_SYSCALL_SLEEP)
SYSCALL(mth_puts, METHOS_SYSCALL_PUTS)
SYSCALL(mth_gets, METHOS_SYSCALL_GETS)
SYSCALL(mth_lock, METHOS_SYSCALL_LOCK)
SYSCALL(mth_unlock, METHOS_SYSCALL_UNLOCK)
SYSCALL(mth_process_create, METHOS_SYSCALL_PROCESSCREATE)
SYSCALL(mth_process_loadelf, METHOS_SYSCALL_PROCESSLOADELF)
SYSCALL(mth_process_join, METHOS_SYSCALL_PROCESSJOIN)
SYSCALL(mth_process_list, METHOS_SYSCALL_PROCESSLIST)
SYSCALL(mth_process_number, METHOS_SYSCALL_PROCESSNUMBER)
SYSCALL(mth_fopen, METHOS_SYSCALL_FOPEN)
SYSCALL(mth_fclose, METHOS_SYSCALL_FOPEN)
SYSCALL(mth_fileexists, METHOS_SYSCALL_FILEEXISTS)
SYSCALL(mth_message_send, METHOS_SYSCALL_MESSAGESEND)
SYSCALL(mth_message_receive, METHOS_SYSCALL_MESSAGERECEIVE)
SYSCALL(mth_fprintf, METHOS_SYSCALL_FPRINTF)
SYSCALL(mth_fputs, METHOS_SYSCALL_FPUTS)
SYSCALL(mth_fgets, METHOS_SYSCALL_FGETS)
SYSCALL(mth_feof, METHOS_SYSCALL_FEOF)
SYSCALL(mth_process_kill, METHOS_SYSCALL_PROCESSKILL)
SYSCALL(srand, METHOS_SYSCALL_SRAND)
SYSCALL(rand, METHOS_SYSCALL_RAND)
SYSCALL(atoi, METHOS_SYSCALL_ATOI)
SYSCALL(mth_time, METHOS_SYSCALL_TIME)
SYSCALL(mth_process_yield, METHOS_SYSCALL_PROCESSYIELD)
SYSCALL(mth_process_settype, METHOS_SYSCALL_PROCESSSETTYPE)
SYSCALL(mth_process_gettype, METHOS_SYSCALL_PROCESSGETTYPE)
